/*

Anicka <anicka@anicka.net> used me to teach her how Cormack's perfect hashinh
works. 

Feel free to use me in any way you want.

Basic usage: compile, execute, enter any non-negative number (no control of
input, negative numbers will break it), watch the changes of the structure, try
again

*/

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#include "common.h"

#define FS 4096 // number of records in a file
#define AS 13 // the happiest prime ever

static inline int
H(int k, int s)
{
	return k % s;
}

// feel free to research anything that works better, no idea
static inline int
Hi(int i, int k, int r)
{
	return (k % ((2 * i) + (100 * r) + 1)) % r;
//	return (k >> i) % r;
}

/* keys are positive integers, negative integers mark absence of the record */
struct rec
{
	int key;
};

struct head
{
	struct rec* p;
	int i;
	int r;
};

struct rec file[FS];
struct head addr[AS];

// completely useless
static void
copy_rec(struct rec* src, struct rec* dst)
{
	dst->key = src->key;
}

// find some continuous blocks of free space, ZAVES
static struct rec* 
find_space(int s)
{
	int i, count = 0;

	for(i = 0; i < FS; i++) {
		if (file[i].key >= 0) {
			count = 0;	
		} else
			count++;

		if (count == s) {
			if (debug)
				printf("Found space at position %d\n", i + 1 - s);
			return (file + i + 1 - s);
		}
	}
	return NULL; 
}

static int
insert(struct rec r)
{
	int i, j, k, m, rr;
	struct rec* pf;

	j = H(r.key, AS);

	if (!addr[j].p){
		pf = find_space(1); //get free space
		if (!pf)
			die("Could not allocate any free space, sorry fish");
		copy_rec(&r, pf); //save to the file
		addr[j].p = pf; addr[j].i = 0; addr[j].r = 1; // update info in head
		return 0;
	}

	rr = addr[j].r;
	//check that key is not already present
	for (i = 0; i < rr; i++){
		if (addr[j].p[i].key == r.key)
			return 1;
	}	

	//find m such that all the values in one cluster differ
	bool check[rr+1];
	m = -1;
	i = 0;
	while (m < 0) {
		memset(check, 0, sizeof(bool) * (rr + 1));
		check[Hi(i, r.key, rr+1)]++;
		for (k = 0; k < rr; k++) {
			if (check[Hi(i, addr[j].p[k].key, rr + 1)]++)
				break;
		}
		if (k == rr) { //if we run until the end
			m = i; //we found our m, otherwise we try next i
		}
		i++;
		if (! (i % 1000000))
			printf("The turtle is still moving... %d\n", i);
		if (i < 0) // HACK, might not work for you
			die("If you can see this message, Cormack je vul");
	}
	pf = find_space(rr + 1);
	if (!pf)
		die("Could not allocate any free space, sorry jellyfish");
	copy_rec(&r, pf + Hi(m, r.key, rr + 1));
	for (i = 0; i < rr; i++){
		copy_rec(addr[j].p + i, pf +  Hi(m, addr[j].p[i].key, rr + 1));
		(addr[j].p + i)->key = -1; // and delete it
	}
	// update head
	addr[j].p = pf; addr[j].i = m; addr[j].r++;

	return 0;		
}

//FIXME - quite inefficient
static void
init(void)
{
	int i;
	for (i = 0; i < FS; i++) {
		file[i].key = -1;
	}

	memset(addr, 0, AS * sizeof(struct head));
}

//never used and tested
static struct rec*
find(int k)
{
	int j;
	j = H(k, AS);
	
	if (! addr[j].r)
		return NULL;
	if ((addr[j].p + Hi(addr[j].i, k, addr[j].r))->key != k)
		return NULL;
	return addr[j].p + Hi(addr[j].i, k, addr[j].r);
}

static void
print_head(void)
{
	int i;
	
	for(i = 0; i < AS; i++){
		printf("line %d: p: %ld,\ti: %d,\tr: %d\n", i, (addr[i].p? addr[i].p - file: 0),
			addr[i].i, addr[i].r);
	}
}

static void
print_file(void)
{
	int i;

	for (i = 0; i < FS; i++) {
		if (file[i].key >= 0)
			printf("line %d: value %d\n", i, file[i].key);
	}
}

int
main(void)
{
	struct rec r;
	int d, i = 0;

	init();
	while (1) {
		printf("Next number, %s?\n", i++ % 2? "sidi": "efendi");
		scanf("%d", &r.key);
		d = insert(r);
		if (debug) 
			printf("Insert %s\n",d? "failed": "ok");
		puts("head");
		print_head();
		puts("data");
		print_file();
	}

	return 0;
}
